#!/usr/local/perl/bin/perl/
##!/usr/bin/perl -w

#!/usr/local/perl/bin/perl/

#Verifica frase per frase (in formato TUT) la presenza di indici non conformi a CoNLL e li modifica.
#Mette nell'array indexes l'indice di ogni parola annotata seguito da = e da un nuovo indice definito da un contatore.
#(il nuovo indice corrisponde alla riga in modo che la parola che sta sulla riga n-esima della frase avra' nuovo indice n).
#L'array conterra' pertanto delle equazioni A=B; fino a quando non viene incontrato un indice non conforme a CoNLL
#le equazioni conterranno A e B uguali, poi, dal momento che un indice non conforme e' stato incontrato, le equazioni 
#conterranno A diverso da B. Per ogni indice in cui A diverso da B il programma sostituisce tutte le occorrenze di A 
#(come indice, come testa o come coreferenti di traccia).

#Inoltre elimina tutte le linee dei file di input contenti MARKER (non annotati)

#Elimina tutte le tracce presenti nel formato TUT nativo


@nodes = ();       	#array che conterra le parole della frase=nodi
@indexes = ();		#array che contiene gli indici dei nodi
$finefrase = 0;      #la var di fine frase e
$contit = 0;          #la var che segnala titolo trovato
$filefrasi = '';
while (<>){         		#fino a quando ci sono righe di input
		$test = 0;           	       		#inizializza la variabile di uscita $test
		while ($test == 0){			#fino quando test vale 0
				$riga = $_;			                        #legge la riga di input
				$stringa = sprintf "%s", $riga;     	        #la converte in stringa
				$inizio = substr $stringa, 0,5;      	        #legge i primi 5 caratteri
				$annotata = (rindex $stringa, ']') - (rindex $stringa, '[');   #calcola la distanza tra le ultime [ ] (>2 se la riga annotata)
				if (($inizio =~ m/\d/) and ($stringa !~ m/MARKER/) and 
					(($annotata >2) or (($annotata <=2) and ($stringa =~ m/ t \[\]/)))){  #se la riga inizia con numero, annotata e non locuzione rigida
						push (@arrayfrase,$stringa);			#la mette in arrayfrase			
				}
				else {if ($inizio !~ m/\*/){ 		           		#altrimenti se riga vuota
							if ($contit == 0){  	           			#se non ancora  trovato il titolo (prima frase)
									$contit = ++$contit; 	   		#aggiorna la variabile $contit
									$filefrasi = $filefrasi.$titolo;
							}
	      					$finefrase = ++$finefrase;    	    #aggiorna la var che segnala la fine della frase
	      				}
						if ($inizio =~ m/\*/){            		#se la riga e' di **
								$titolo = $stringa;     	      	#assegna il titolo della nuova frase a $titolo
								if ($finefrase != 0){           #se raggiunta fine della frase precedente
										@arrayfrase = delete_traces_from(@arrayfrase);
										$filefrasi = $filefrasi.join("", update_indexes(@arrayfrase))."\n".$titolo;	#richiama update-indexes
										@arrayfrase = ();		#svuota arrayfrase per la nuova frase
										$finefrase = 0;			#riporta la var di finefrase a 0
								}
	      				}
				}
				$test = ++$test;     			#aggiorna la var di uscita
		}
}
#foreach $ee(@arrayfrase){print $ee," in arrayfrase\n";}
@arrayfrase = delete_traces_from(@arrayfrase);
$filefrasi = $filefrasi.join("", update_indexes(@arrayfrase))."\n\n"; 	#richiama update_indexs sull'ultima frase
print $filefrasi,"\n";
	



##### UPDATE_INDEXES #####################################
#aggiorna gli indici che non sono conformi a CoNLL

sub update_indexes{
	my @nodes = @_;
	my @indexes = ();		
  	my $counter = 0;
  	my $posizione = '';
  	my $posizionedoppia = '';
  	foreach $no(@nodes){
  			$counter++;
  			$posizione = calcolaposizione($no);     		#calcola la posizione della stringa nella frase
			$posizionedoppia = $posizione.'='.$counter;		#ci mette dietro il valore del contatore
			push @indexes, $posizionedoppia;    		      	    
	}	
	foreach $kk(@indexes){
			$oldindex = substr $kk,0,(index $kk,'=');
 			$newindex = substr $kk,(index $kk,'=')+1;
 			if ($newindex ne $oldindex){		#per ogni indice che deve essere aggiornato
#print "/////////////////", $kk," da aggiornare\n";
					foreach $nod(@nodes){		#per ogni nodo della frase
							$index = calcolaposizione($nod);		
							$newindexupdt = $newindex.'UPDT';	#attacca UPDT dietro ad ogni indice che aggiorna per evitare aggiornamenti multipli
#print "------------------", $nod,"=nod\n";
							if (($index eq $oldindex) and ($index !~ m/UPDT/)){	#aggiorna l'indice posizionale del nodo
#print "aggiorna posizione di ",$nod,"\n";
									$newnod = $nod;
									$newnod =~ s/$index/$newindexupdt/;
									@nodes = sostituisciinarray($nod,$newnod,@nodes);
#print $nod," diventa ",$newnod,"\n";
									$nod = $newnod;
							}
							if (($nod =~ m/\st\s\[/) and ($nod !~ m/\[\]/)){			#aggiorna il coindice di traccia
									$coindex = calcolacoindicetraccia($nod);	
#print "qui coindex=",$coindex," e oldindex=",$oldindex,"\n";
									if ($coindex eq $oldindex){
#print "aggiorna coindice (=",$coindex,") di ",$nod,"\n";
											$newnod = substr $nod,0,(index $nod,"[")+1;
											$newnod = $newnod.$newindexupdt;
											$newnod = $newnod.(substr $nod,(index $nod,"]")-1);
										#	$newnod =~ s/$coindex/$newindexupdt/;
											@nodes = sostituisciinarray($nod,$newnod,@nodes);
#print $nod," diventa ",$newnod,"\n";
											$nod = $newnod;
									}
							}
							$padre = calcolapadre($nod);
							if (($padre eq $oldindex) and ($padre !~ m/UPDT/)){		#aggiorna il riferimento al padre del nodo
#print "aggiorna padre di ",$nod,"\n";
									$newnod = $nod;
									$newnod = substr $nod,0,(rindex $nod,'[')+1;
									$newnod = $newnod.$newindexupdt.(substr $nod,(rindex $nod,';'));
									@nodes = sostituisciinarray($nod,$newnod,@nodes);
#print $nod," diventa ",$newnod,"\n";
									$nod = $newnod;
							}
					}
			}
	}
 	foreach $el(@nodes){
 			$newel = $el;
			$newel =~ s/UPDT//g;		#elimina tutte le occorrenze di UPDT che ha inserito per segnalare gli indici gia' aggiornati
			@nodes = sostituisciinarray($el,$newel,@nodes);
	}
	return @nodes;
}





####### DELETE_TRACES_FROM ###############################################################
#elimina tutte le tracce presenti nella frase in input, tranne quelle che derivano da VISITOR e quelle che hanno figli

sub delete_traces_from{
	my @frase = @_;
	my @sentence = @frase;
	my @newsentence = ();
	my @traces = ();
	my $soggetto = '';
	my @temp =();
	while (scalar(@sentence) > 0){		
			$ele = shift(@sentence);
			@figliele = ();
			$soggetto = '';
			if (($ele =~ m/p\]/) or ($ele =~ m/w\]/) or ($ele =~ m/f\]/) or ($ele =~ m/\[\]/)){#se ele e' una traccia
#print $ele,"=ele traccia \n";	
#print "metto ",$ele," in temp\n";
					@figliele = figli($ele,@frase);	#trova i figli di ele
					if (scalar(@figliele) != 0){
							push(@temp,$ele);
							if (($ele =~ m/VERB MAIN/) and ($ele =~ m/t \[\]/)){	#se e' una testa verbale non coindicizzata
#print $ele," verb main traccia\n";
									foreach $figlio(@figliele){	#per ogni figlio di ele
#print $figlio,"=figlio di ele\n";
											if (($figlio =~ m/SUBJ/) and ($figlio !~ m/PREDCOMPL/) and 
												(($figlio !~ m/p\]/) and ($figlio !~ m/f\]/) and ($figlio !~ m/w\]/) and ($figlio !~ m/\[\]/))){#se e' soggetto diventa testa
														$soggetto = $figlio;
														$newfiglio = substr $figlio,0,(rindex $figlio,'[');		
														if ($ele =~ m/\;TOP/){#con relazione top se ele era testa di tutta la frase
																$newfiglio = $newfiglio.'['.(calcolapadre($ele)).";TOPGAP]\n";
#print $figlio," SOGGETTO TESTA diventa ",$newfiglio,"=newfiglio\n";
																push(@newsentence,$newfiglio);
																push(@temp,$figlio);
															#	@sentence = delete_traces_from(@sentence);
															#	@newsentence = delete_traces_from(@newsentence);
														}
														else{$newfiglio = $newfiglio.(substr $ele,(rindex $ele, '['));#con la stessa relazione di ele altrimenti
#print $figlio," SOGGETTO NON-TESTA diventa ",$newfiglio,"=newfiglio\n";
																push(@newsentence,$newfiglio);
																push(@temp,$figlio);
															#	@sentence = delete_traces_from(@sentence);
															#	@newsentence = delete_traces_from(@newsentence);
														}
											}
									}
									foreach $figlio(@figliele){
											if ((($figlio !~ m/SUBJ/) or ($figlio =~ m/PREDCOMPL/)) and
												(($figlio !~ m/p\]/) and ($figlio !~ m/f\]/) and ($figlio !~ m/w\]/) and ($figlio !~ m/\[\]/))){
														$newfiglio = substr $figlio,0,(rindex $figlio,'[');		#se non e' soggetto diventa figlio del soggetto	
														if ($soggetto ne ''){
																$newfiglio = $newfiglio.'['.(calcolaposizione($soggetto)).";PREDGAP]\n";
#print $figlio," NON-SOGGETTO (ma esitente soggetto) diventa ",$newfiglio,"=newfiglio\n";									
														}
														else{$newfiglio = $newfiglio."[0;PREDGAP]\n";
#print $figlio," NON-SOGGETTO  (non esistente soggetto) diventa ",$newfiglio,"=newfiglio\n";
														}
#print $figlio," diventa ",$newfiglio,"=newfiglio\n";
														push(@newsentence,$newfiglio);
														push(@temp,$figlio);
											}		
									}
							}
							else{foreach $figlio(@figliele){
											if (($figlio !~ m/p\]/) and ($figlio !~ m/f\]/) and ($figlio !~ m/w\]/) and ($figlio !~ m/\[\]/)){
													$newfiglio = substr $figlio,0,(rindex $figlio,'[');	
													if (calcolapadre($ele) =~ m/\./){
															if (calcolapadre(padre($ele,@frase)) !~ m/\./){
																	$newfiglio = $newfiglio."[".(calcolapadre(padre($ele,@frase))).(substr $figlio,(rindex $figlio,';'));
															}
															else{$newpadre = padre($ele,@frase);
																	while (calcolapadre($newpadre,@frase) =~ m/\./){
																				$newpadre = padre($ele,@frase);
																				$ele = $newpadre;
																	}
															$newfiglio = $newfiglio."[".(calcolapadre(padre($newpadre,@frase))).(substr $figlio,(rindex $figlio,';'));
															}
													}
													else{$newfiglio = $newfiglio."[".(calcolapadre($ele)).(substr $figlio,(rindex $figlio,';'));
													}
#print $figlio," diventaaa ",$newfiglio,"=newfiglio\n";
													push(@newsentence,$newfiglio);
													push(@temp,$figlio);
											}
									}
							}
					}
					else{push(@temp,$ele);
#print "metto ",$ele," in temp\n";
					}
			}
	}
	foreach $rr(@frase){
			$trovato = 'no';
			foreach $tt(@temp){
					if ($rr eq $tt){
							$trovato = 'si';
	#print $rr,"=rr ",$tt,"=tt\n";
					}
			}
			if ($trovato ne 'si'){
	#print $rr," in newsentence\n";
					push(@newsentence,$rr);
			}
	}
	@sortednewsentence = sort {comparpos($a,$b)}@newsentence; #ordina in base alla posizione
	return @sortednewsentence;
}


sub comparpos{return (calcolaposizione(shift(@_)) <=> calcolaposizione(shift(@_)));
}






################  CALCOLAPOSIZIONE  #######################################################
#calcola la posizione (primi caratteri) della stringa data come argomento

sub calcolaposizione{
	my $arg = shift(@_);
	$primospazio = '';
	$posizione = '';
	$primospazio = substr $arg, 0,2;          	
        if ($primospazio =~ m/\s/){
		$posizione = substr $arg, 0,1;
	}
	else {$primospazio = substr $arg, 0,3;
		if ($primospazio =~ m/\s/){
			$posizione = substr $arg, 0,2;
		}
		else{$primospazio = substr $arg, 0,4;
			if ($primospazio =~ m/\s/){
				$posizione = substr $arg, 0,3;
			}
			else{$primospazio = substr $arg, 0,5;
				if ($primospazio =~ m/\s/){
					$posizione = substr $arg, 0,4;
				}
				else{$posizione = substr $arg, 0,5;
				}
			}
		}
	}
}



################  CALCOLACOINDICETRACCIA  #######################################################
#calcola la coindicizzazione presente nella stringa data come argomento

sub calcolacoindicetraccia{
	my $arg = shift(@_);
	my $coindex = '';			
	$coindex = substr $arg,(index $arg, ' t [')+4;
	$coindex = substr $coindex,0,(index $coindex,']')-1;
#print $coindex,"=coindice\n";
	return $coindex;
}



################  CALCOLAPADRE #######################################################
#calcola la posizione del padre della stringa data come argomento

sub calcolapadre{
	my $arg = shift(@_);
	my $padre = '';
	$padre = substr $arg,(rindex $arg,'[');
	$padre = substr $padre,1,(index $padre,';')-1;
#print $padre,"=padre\n";
	return $padre;
}


sub padre{
	my $arg = shift(@_);
	my @frase = @_;
	my $padre = '';
	my $pospadre = calcolapadre($arg);
	foreach $elemento(@frase){
			if (calcolaposizione($elemento) eq $pospadre){
					$padre = $elemento;
			}
	}
	return $padre;
}
################# CERCA_VISITOR_FOR ####################################################
#restituisce si se l'argomento e' coindicizzato con un visitor, non altrimenti

sub cerca_visitor_for{
		my $arg = shift(@_);
		my @frase = @_;
		my $visitor = 'no';
		my $coindice = calcolacoindicetraccia;
		foreach $item(@frase){
				$coindiceitem = calcolacoindicetraccia($item);
				if (($coindiceitem eq $coindice) and ($item =~ m/VISITOR/)){
						$visitor = 'si';
				}
		}
	return $visitor;
}




################ FIGLI ###############################################################
#trova gli eventuali figli del nodo dato come argomento

sub figli{
	my $arg =  $_[0];
	my @frase = @_[1..$#_];
	my $posiz = '';
	my @arrayfigli = ();
	my $posarg = calcolaposizione($arg);
	foreach $elem (@frase){                #per ogni elemento della frase
		$pospadreelem = calcolapadre($elem);    #calcola la posizione del padre
		if ($pospadreelem eq $posarg){     #e la confronta con la posizione di $arg
			push(@arrayfigli,$elem);  #se corrispondono mette l'elemento nell'array dei figli
		}
	}
return @arrayfigli;
}


#### sostituisciinarray ##################################################################################
#la subroutine sostituisciinarray sostituisce il primo parametro con il secondo parametro all'interno
#di un array che gli viene passato come terzo parametro

sub sostituisciinarray {
	my $vecchio = shift(@_);
    my $nuovo = shift(@_);
	my @array = @_;
	my @arraytemp1 = ();
	foreach $elemento(@array){
		if ($elemento ne $vecchio){
			push (@arraytemp1,$elemento);
		}
		else {push (@arraytemp1,$nuovo);
		}
	}
	@array = @arraytemp1;
return @array;
}



#### cancelladaarray ##################################################################################
#la subroutine cancelladaarray toglie il primo parametro dal secondo parametro che e' un array

sub cancelladaarray {
	my $elemento = shift(@_);
       	my @array = @_;
	my @arraytemp1 = ();
	foreach $elem(@array){
		if ($elem ne $elemento){
			push (@arraytemp1,$elem);
		}
	}
	@array = @arraytemp1;
return @array;
}